searchData={"items":[{"type":"module","title":"Runlet","doc":"","ref":"Runlet.html"},{"type":"function","title":"Runlet.compile/1","doc":"","ref":"Runlet.html#compile/1"},{"type":"function","title":"Runlet.exec/2","doc":"","ref":"Runlet.html#exec/2"},{"type":"function","title":"Runlet.fork/1","doc":"","ref":"Runlet.html#fork/1"},{"type":"function","title":"Runlet.jobctrl?/1","doc":"","ref":"Runlet.html#jobctrl?/1"},{"type":"function","title":"Runlet.start_link/0","doc":"","ref":"Runlet.html#start_link/0"},{"type":"type","title":"Runlet.t/0","doc":"","ref":"Runlet.html#t:t/0"},{"type":"module","title":"Runlet.CLI","doc":"Compile runlet expressions","ref":"Runlet.CLI.html"},{"type":"function","title":"Runlet.CLI.append/2","doc":"Add a runlet expression to the end of a pipeline.","ref":"Runlet.CLI.html#append/2"},{"type":"function","title":"Examples - Runlet.CLI.append/2","doc":"iex> Runlet.CLI.append(~s(test \"foo\" | bar 123 | another), ~s(insert | here))\n    {:ok,\n     [{\"test\", [\"foo\"]}, {\"bar\", '{'}, {\"another\", []}, {\"insert\", []},\n      {\"here\", []}]}","ref":"Runlet.CLI.html#append/2-examples"},{"type":"function","title":"Runlet.CLI.compile/1","doc":"Compile a runlet expression to AST\n\nCommands are looked up in the application environment:\n\n    Application.get_env(:runlet, :aliases, [])","ref":"Runlet.CLI.html#compile/1"},{"type":"function","title":"Runlet.CLI.compile/2","doc":"Compile a runlet expression to AST","ref":"Runlet.CLI.html#compile/2"},{"type":"function","title":"Examples - Runlet.CLI.compile/2","doc":"iex> Runlet.CLI.compile(\n    ...>   ~s(test \"foo\" | bar 123),\n    ...>   [{\"test\", [{[:Fake, :Cmd, :AddArg], :exec},\n    ...>              {{:Fake, :Cmd, :StaticArg}, [\"static arg\"]}]},\n    ...>    {\"bar\", {[:Fake, :Cmd, :IntArg], :exec}}])\n    {:ok,\n     {:|>, [context: Elixir, import: Kernel],\n      [{:|>, [context: Elixir, import: Kernel],\n        [{{:., [], [{:__aliases__, [alias: false], [:Fake, :Cmd, :AddArg]}, :exec]},\n          [], [\"foo\"]},\n         {{:., [],\n           [{:__aliases__, [alias: false], {:Fake, :Cmd, :StaticArg}},\n            [\"static arg\"]]}, [], [\"foo\"]}]},\n       {{:., [], [{:__aliases__, [alias: false], [:Fake, :Cmd, :IntArg]}, :exec]},\n        [], '{'}]}}","ref":"Runlet.CLI.html#compile/2-examples"},{"type":"function","title":"Runlet.CLI.compile!/1","doc":"Compile a runlet expression to AST.\n\nCommands are looked up in the application environment:\n\n    Application.get_env(:runlet, :aliases, [])","ref":"Runlet.CLI.html#compile!/1"},{"type":"function","title":"Runlet.CLI.compile!/2","doc":"Compile a runlet expression to AST.","ref":"Runlet.CLI.html#compile!/2"},{"type":"function","title":"Examples - Runlet.CLI.compile!/2","doc":"iex> Runlet.CLI.compile!(\n    ...>   ~s(test \"foo\" | bar 123),\n    ...>   [{\"test\", [{[:Fake, :Cmd, :AddArg], :exec},\n    ...>              {{:Fake, :Cmd, :StaticArg}, [\"static arg\"]}]},\n    ...>    {\"bar\", {[:Fake, :Cmd, :IntArg], :exec}}])\n    {:|>, [context: Elixir, import: Kernel],\n     [{:|>, [context: Elixir, import: Kernel],\n       [{{:., [], [{:__aliases__, [alias: false], [:Fake, :Cmd, :AddArg]}, :exec]},\n         [], [\"foo\"]},\n        {{:., [],\n          [{:__aliases__, [alias: false], {:Fake, :Cmd, :StaticArg}},\n           [\"static arg\"]]}, [], [\"foo\"]}]},\n      {{:., [], [{:__aliases__, [alias: false], [:Fake, :Cmd, :IntArg]}, :exec]},\n       [], '{'}]}","ref":"Runlet.CLI.html#compile!/2-examples"},{"type":"function","title":"Runlet.CLI.insert/3","doc":"Insert a runlet pipeline into another pipeline.","ref":"Runlet.CLI.html#insert/3"},{"type":"function","title":"Examples - Runlet.CLI.insert/3","doc":"iex> Runlet.CLI.insert(~s(test \"foo\" | bar 123 | another),\n    ...>   ~s(insert | here), 2)\n    {:ok,\n     [{\"test\", [\"foo\"]}, {\"bar\", '{'}, {\"insert\", []}, {\"here\", []},\n      {\"another\", []}]}","ref":"Runlet.CLI.html#insert/3-examples"},{"type":"function","title":"Runlet.CLI.lex/1","doc":"Tokenize a runlet expression.","ref":"Runlet.CLI.html#lex/1"},{"type":"function","title":"Examples - Runlet.CLI.lex/1","doc":"iex> Runlet.CLI.lex(~s(test \"foo\" | bar 123 | out > 456))\n    {:ok,\n       [\n         {:command, 1, \"test\"},\n         {:string, 1, 'foo'},\n         {:|, 1},\n         {:command, 1, \"bar\"},\n         {:integer, 1, 123},\n         {:|, 1},\n         {:command, 1, \"out\"},\n         {:>, 1},\n         {:integer, 1, 456}\n       ], 1}","ref":"Runlet.CLI.html#lex/1-examples"},{"type":"function","title":"Runlet.CLI.parse/1","doc":"Parse a runlet expression.","ref":"Runlet.CLI.html#parse/1"},{"type":"function","title":"Examples - Runlet.CLI.parse/1","doc":"iex> Runlet.CLI.parse(~s(test \"foo\" | bar 123 | out > 456))\n    {:ok, [{\"test\", [\"foo\"]}, {\"bar\", '{'}, {\"out\", []}, {\">\", [456]}]}","ref":"Runlet.CLI.html#parse/1-examples"},{"type":"function","title":"Runlet.CLI.prepend/2","doc":"Add a runlet expression at the start of a pipeline.","ref":"Runlet.CLI.html#prepend/2"},{"type":"function","title":"Examples - Runlet.CLI.prepend/2","doc":"iex> Runlet.CLI.prepend(~s(test \"foo\" | bar 123 | another), ~s(insert | here))\n    {:ok,\n     [{\"insert\", []}, {\"here\", []}, {\"test\", [\"foo\"]}, {\"bar\", '{'},\n      {\"another\", []}]}","ref":"Runlet.CLI.html#prepend/2-examples"},{"type":"function","title":"Runlet.CLI.substitute/3","doc":"","ref":"Runlet.CLI.html#substitute/3"},{"type":"type","title":"Runlet.CLI.e/0","doc":"","ref":"Runlet.CLI.html#t:e/0"},{"type":"type","title":"Runlet.CLI.t/0","doc":"","ref":"Runlet.CLI.html#t:t/0"},{"type":"module","title":"Runlet.Cmd.Abort","doc":"Abort pipeline if rate limit exceeded","ref":"Runlet.Cmd.Abort.html"},{"type":"function","title":"Runlet.Cmd.Abort.exec/3","doc":"Places a maximum rate limit on an event stream. Exceeding the limit\nterminates the process.\n\n      # abort if number of events exceeds 5 in 2 minutes\n      abort 5 120","ref":"Runlet.Cmd.Abort.html#exec/3"},{"type":"module","title":"Runlet.Cmd.Dedup","doc":"Deduplicate repeated events","ref":"Runlet.Cmd.Dedup.html"},{"type":"function","title":"Runlet.Cmd.Dedup.exec/3","doc":"Suppress repeated events in a stream:\n\n    arg: \"keys\" \"vals\"\n\n    dedup \"host service\" \"description\"","ref":"Runlet.Cmd.Dedup.html#exec/3"},{"type":"module","title":"Runlet.Cmd.Fifo","doc":"Create a named fifo as the input to a runlet","ref":"Runlet.Cmd.Fifo.html"},{"type":"function","title":"Runlet.Cmd.Fifo.exec/1","doc":"Use a named fifo for runlet input.\n\nCreates a fifo. One or more runlets can send events to the fifo. If\nthe fifo does not exist, events are discarded.\n\n    fifo foo\n    runtime > foo","ref":"Runlet.Cmd.Fifo.html#exec/1"},{"type":"module","title":"Runlet.Cmd.Filter","doc":"Filter events based on a regular expression","ref":"Runlet.Cmd.Filter.html"},{"type":"function","title":"Runlet.Cmd.Filter.exec/2","doc":"Filter events using a regexp. The value of each JSON key is matched\nagainst the regexp.\n\nIt may be more efficient to write a query. For example, instead\nof running:\n\n    query 'service ~= \"foo\"' | filter \"bar\"\n\nUse:\n\n    query 'service ~= \"foo\" and not description ~= \"bar\"'","ref":"Runlet.Cmd.Filter.html#exec/2"},{"type":"module","title":"Runlet.Cmd.Flow","doc":"Flow control events","ref":"Runlet.Cmd.Flow.html"},{"type":"function","title":"Runlet.Cmd.Flow.exec/3","doc":"Drop events that exceed a rate in count per seconds.","ref":"Runlet.Cmd.Flow.html#exec/3"},{"type":"module","title":"Runlet.Cmd.Fmt","doc":"Format events","ref":"Runlet.Cmd.Fmt.html"},{"type":"function","title":"Runlet.Cmd.Fmt.exec/1","doc":"Formats JSON into output similar to syslog.","ref":"Runlet.Cmd.Fmt.html#exec/1"},{"type":"module","title":"Runlet.Cmd.Grep","doc":"Output events matching a regular expression","ref":"Runlet.Cmd.Grep.html"},{"type":"function","title":"Runlet.Cmd.Grep.exec/2","doc":"Select events using a regexp. The value of each JSON key is matched\nagainst the regexp.","ref":"Runlet.Cmd.Grep.html#exec/2"},{"type":"function","title":"Runlet.Cmd.Grep.to_bin/1","doc":"","ref":"Runlet.Cmd.Grep.html#to_bin/1"},{"type":"module","title":"Runlet.Cmd.Limit","doc":"Limit events to count per seconds","ref":"Runlet.Cmd.Limit.html"},{"type":"function","title":"Runlet.Cmd.Limit.exec/3","doc":"Set upper limit on the number of events permitted per *seconds*\nseconds. Events exceeding this rate are discarded.","ref":"Runlet.Cmd.Limit.html#exec/3"},{"type":"module","title":"Runlet.Cmd.Query","doc":"Query a riemann server","ref":"Runlet.Cmd.Query.html"},{"type":"function","title":"Runlet.Cmd.Query.exec/1","doc":"Filters events from a riemann server using the Riemann query\nlanguage. The query must be quoted as a string:\n\n    'state = \"ok\"'\n\nExamples of Queries:\n\n    # Simple equality\n    state = \"ok\"\n\n    # Wildcards\n    (service =~ \"disk%\") or\n    (state != \"critical\" and host =~ \"%.trioptimum.com\")\n\n    # Standard operator precedence applies\n    metric_f > 2.0 and not host = nil\n\n    # Anything with a tag \"product\"\n    tagged \"product\"\n\n    # All states\n    true\n\nExamples from the test suite:\n\nhttps://github.com/riemann/riemann/blob/master/test/riemann/query_test.clj\n\nQuery Grammar:\n\nhttps://github.com/riemann/riemann/blob/master/resources/query.g4","ref":"Runlet.Cmd.Query.html#exec/1"},{"type":"type","title":"Runlet.Cmd.Query.t/0","doc":"","ref":"Runlet.Cmd.Query.html#t:t/0"},{"type":"module","title":"Runlet.Cmd.Rate","doc":"Calculate event rate","ref":"Runlet.Cmd.Rate.html"},{"type":"function","title":"Runlet.Cmd.Rate.exec/2","doc":"Generates an event every *seconds* seconds consisting of the event\nstream rate per second.","ref":"Runlet.Cmd.Rate.html#exec/2"},{"type":"module","title":"Runlet.Cmd.Runtime","doc":"Output the bot uptime","ref":"Runlet.Cmd.Runtime.html"},{"type":"function","title":"Runlet.Cmd.Runtime.exec/0","doc":"Output the bot uptime.","ref":"Runlet.Cmd.Runtime.html#exec/0"},{"type":"module","title":"Runlet.Cmd.Select","doc":"Select keys from JSON","ref":"Runlet.Cmd.Select.html"},{"type":"function","title":"Runlet.Cmd.Select.exec/2","doc":"Select a subset of keys from the JSON key/value pairs.","ref":"Runlet.Cmd.Select.html#exec/2"},{"type":"module","title":"Runlet.Cmd.Stdin","doc":"Sends output from a pipeline to another process","ref":"Runlet.Cmd.Stdin.html"},{"type":"function","title":"Runlet.Cmd.Stdin.exec/2","doc":"Sends output from a pipeline to another process.","ref":"Runlet.Cmd.Stdin.html#exec/2"},{"type":"module","title":"Runlet.Cmd.Suppress","doc":"Ignore events for a time period in seconds","ref":"Runlet.Cmd.Suppress.html"},{"type":"function","title":"Runlet.Cmd.Suppress.exec/2","doc":"Sets a timer and ignores any events until the timer fires.\n\nCan be used for long running commands that always output on start.\n\nArgs:\n\n    suppress","ref":"Runlet.Cmd.Suppress.html#exec/2"},{"type":"type","title":"Runlet.Cmd.Suppress.t/0","doc":"","ref":"Runlet.Cmd.Suppress.html#t:t/0"},{"type":"module","title":"Runlet.Cmd.Take","doc":"Take a number of events from the stream","ref":"Runlet.Cmd.Take.html"},{"type":"function","title":"Runlet.Cmd.Take.exec/2","doc":"Takes *count* events from the stream and terminates the stream.","ref":"Runlet.Cmd.Take.html#exec/2"},{"type":"module","title":"Runlet.Cmd.Threshold","doc":"Passes events over a minimum limit","ref":"Runlet.Cmd.Threshold.html"},{"type":"function","title":"Runlet.Cmd.Threshold.exec/3","doc":"Events below the threshold are suppressed. If the number of events in\n*seconds* seconds exceeds the threshold, all events, including events\nthat were suppressed, are passed.","ref":"Runlet.Cmd.Threshold.html#exec/3"},{"type":"module","title":"Runlet.Cmd.Timeout","doc":"Abort the event stream after a timeout","ref":"Runlet.Cmd.Timeout.html"},{"type":"function","title":"Runlet.Cmd.Timeout.exec/2","doc":"Terminates the stream if no events arrive before a timeout.","ref":"Runlet.Cmd.Timeout.html#exec/2"},{"type":"module","title":"Runlet.Cmd.Valve","doc":"Asynchronously start/stop the event stream","ref":"Runlet.Cmd.Valve.html"},{"type":"function","title":"Runlet.Cmd.Valve.exec/1","doc":"Allows dynamically starting/stopping the event stream using the\nstart/stop commands. While stopped, events are discarded.","ref":"Runlet.Cmd.Valve.html#exec/1"},{"type":"module","title":"Runlet.Config","doc":"This module handles fetching values from the config with some additional niceties","ref":"Runlet.Config.html"},{"type":"function","title":"Runlet.Config.get/3","doc":"Fetches a value from the config, or from the environment if {:system, \"VAR\"}\nis provided.\n\nAn optional default value can be provided if desired.","ref":"Runlet.Config.html#get/3"},{"type":"function","title":"Example - Runlet.Config.get/3","doc":"iex> Application.put_env(:myapp, :test_var2, 1)\n    ...> 1 = Elixir.Runlet.Config.get(:myapp, :test_var2)\n    1\n\n    iex> :default = Elixir.Runlet.Config.get(:myapp, :missing_var, :default)\n    :default","ref":"Runlet.Config.html#get/3-example"},{"type":"module","title":"Runlet.Ctrl.Exit","doc":"Request a process to exit","ref":"Runlet.Ctrl.Exit.html"},{"type":"function","title":"Runlet.Ctrl.Exit.exec/2","doc":"Causes the event stream associated with a PID to exit.","ref":"Runlet.Ctrl.Exit.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.Exit.exec/3","doc":"","ref":"Runlet.Ctrl.Exit.html#exec/3"},{"type":"module","title":"Runlet.Ctrl.Flow","doc":"dynamically change flow control for a running event stream","ref":"Runlet.Ctrl.Flow.html"},{"type":"function","title":"Runlet.Ctrl.Flow.exec/2","doc":"Alters the flow control for a running process to 1/minute.","ref":"Runlet.Ctrl.Flow.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.Flow.exec/4","doc":"Alters the flow control for a running process or processes to count\nevents in minutes:\n\n    # pid 1234: 10 events/2 minutes\n    flow 1234 10 2\n\n    # pids 1234, 2345, 123456\n    flow \"1234 2345 12346\" 10 2","ref":"Runlet.Ctrl.Flow.html#exec/4"},{"type":"function","title":"Runlet.Ctrl.Flow.exec/5","doc":"Alters the flow control for several processes running as a different\nuser to count events in minutes.\n\n    flow 1234 10 2 \"nobody\"\n    flow \"1234 2345 12346\" 10 2 \"nobody\"","ref":"Runlet.Ctrl.Flow.html#exec/5"},{"type":"module","title":"Runlet.Ctrl.Fmt","doc":"Toggle formatting of JSON","ref":"Runlet.Ctrl.Fmt.html"},{"type":"function","title":"Runlet.Ctrl.Fmt.exec/2","doc":"Enables/disables formatting of JSON for a process.","ref":"Runlet.Ctrl.Fmt.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.Fmt.exec/3","doc":"","ref":"Runlet.Ctrl.Fmt.html#exec/3"},{"type":"module","title":"Runlet.Ctrl.Halt","doc":"Shutdown the system","ref":"Runlet.Ctrl.Halt.html"},{"type":"function","title":"Runlet.Ctrl.Halt.exec/1","doc":"Requests the system to shut down.","ref":"Runlet.Ctrl.Halt.html#exec/1"},{"type":"function","title":"Runlet.Ctrl.Halt.exec/2","doc":"Requests the system to shut down after the specified number of seconds:\n\n    halt 10","ref":"Runlet.Ctrl.Halt.html#exec/2"},{"type":"module","title":"Runlet.Ctrl.Help","doc":"Provide help for a command","ref":"Runlet.Ctrl.Help.html"},{"type":"function","title":"Runlet.Ctrl.Help.exec/1","doc":"Provide command summaries.","ref":"Runlet.Ctrl.Help.html#exec/1"},{"type":"function","title":"Runlet.Ctrl.Help.exec/2","doc":"Provide help for command.","ref":"Runlet.Ctrl.Help.html#exec/2"},{"type":"module","title":"Runlet.Ctrl.History","doc":"List and run items from command history","ref":"Runlet.Ctrl.History.html"},{"type":"function","title":"Runlet.Ctrl.History.exec/1","doc":"List command history.","ref":"Runlet.Ctrl.History.html#exec/1"},{"type":"function","title":"Runlet.Ctrl.History.exec/2","doc":"Run commands from history:\n\n    h 10\n    h \"10 11 34\"","ref":"Runlet.Ctrl.History.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.History.run/1","doc":"","ref":"Runlet.Ctrl.History.html#run/1"},{"type":"module","title":"Runlet.Ctrl.HistoryDelete","doc":"Delete items from history","ref":"Runlet.Ctrl.HistoryDelete.html"},{"type":"function","title":"Runlet.Ctrl.HistoryDelete.exec/2","doc":"Deletes items from the history:\n\n    hd 4\n    hd \"1 2 4 6\"","ref":"Runlet.Ctrl.HistoryDelete.html#exec/2"},{"type":"module","title":"Runlet.Ctrl.HistoryUser","doc":"View/run another user's history","ref":"Runlet.Ctrl.HistoryUser.html"},{"type":"function","title":"Runlet.Ctrl.HistoryUser.exec/2","doc":"View another user's history.","ref":"Runlet.Ctrl.HistoryUser.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.HistoryUser.exec/3","doc":"Run a command from another user's history.","ref":"Runlet.Ctrl.HistoryUser.html#exec/3"},{"type":"module","title":"Runlet.Ctrl.Kill","doc":"Terminate a running event stream process","ref":"Runlet.Ctrl.Kill.html"},{"type":"function","title":"Runlet.Ctrl.Kill.exec/2","doc":"Terminate the process running an event stream. Accepts a PID or a list\nof PIDs:\n\n    kill 1234\n    kill \"1234\"\n    kill \"1234 123.5 1256\"","ref":"Runlet.Ctrl.Kill.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.Kill.exec/3","doc":"Terminate a process run by another user. Accepts a PID of a list\nof PIDs:\n\n    kill 1234 \"name\"\n    kill \"1234\" \"name\"\n    kill \"1234 123.5 1256\" \"name\"","ref":"Runlet.Ctrl.Kill.html#exec/3"},{"type":"module","title":"Runlet.Ctrl.Ps","doc":"List running processes","ref":"Runlet.Ctrl.Ps.html"},{"type":"function","title":"Runlet.Ctrl.Ps.exec/1","doc":"List running processes.","ref":"Runlet.Ctrl.Ps.html#exec/1"},{"type":"function","title":"Runlet.Ctrl.Ps.exec/2","doc":"List a user's running processes.","ref":"Runlet.Ctrl.Ps.html#exec/2"},{"type":"module","title":"Runlet.Ctrl.Signal","doc":"Send a signal to a process","ref":"Runlet.Ctrl.Signal.html"},{"type":"function","title":"Runlet.Ctrl.Signal.exec/2","doc":"Sends SIGHUP to a process.","ref":"Runlet.Ctrl.Signal.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.Signal.exec/3","doc":"Sends a signal to a process.","ref":"Runlet.Ctrl.Signal.html#exec/3"},{"type":"module","title":"Runlet.Ctrl.Start","doc":"Start a stopped process","ref":"Runlet.Ctrl.Start.html"},{"type":"function","title":"Runlet.Ctrl.Start.exec/2","doc":"Start a process.","ref":"Runlet.Ctrl.Start.html#exec/2"},{"type":"function","title":"Runlet.Ctrl.Start.exec/3","doc":"Start multiple processes.","ref":"Runlet.Ctrl.Start.html#exec/3"},{"type":"module","title":"Runlet.Ctrl.Stop","doc":"Silence output from running process","ref":"Runlet.Ctrl.Stop.html"},{"type":"function","title":"Runlet.Ctrl.Stop.exec/3","doc":"Stops output from a running process. The process continues to run.\nAfter *timeout* minutes passes, output from the process resumes.","ref":"Runlet.Ctrl.Stop.html#exec/3"},{"type":"function","title":"Runlet.Ctrl.Stop.exec/4","doc":"Stops output stream for list of processes.","ref":"Runlet.Ctrl.Stop.html#exec/4"},{"type":"module","title":"Runlet.Event","doc":"Runlet events","ref":"Runlet.Event.html"},{"type":"function","title":"Runlet.Event.split/2","doc":"Takes all entries corresponding to the given keys in the contained\nevent and extracts them into a separate map.","ref":"Runlet.Event.html#split/2"},{"type":"function","title":"Runlet.Event.to_map/1","doc":"Convert the contained event to a map.","ref":"Runlet.Event.html#to_map/1"},{"type":"type","title":"Runlet.Event.t/0","doc":"","ref":"Runlet.Event.html#t:t/0"},{"type":"module","title":"Runlet.Event.Ctrl","doc":"Runlet control events","ref":"Runlet.Event.Ctrl.html"},{"type":"type","title":"Runlet.Event.Ctrl.t/0","doc":"","ref":"Runlet.Event.Ctrl.html#t:t/0"},{"type":"module","title":"Runlet.Event.Flow","doc":"Runlet flow events","ref":"Runlet.Event.Flow.html"},{"type":"type","title":"Runlet.Event.Flow.t/0","doc":"","ref":"Runlet.Event.Flow.html#t:t/0"},{"type":"module","title":"Runlet.Event.Riemann","doc":"Rieman JSON events","ref":"Runlet.Event.Riemann.html"},{"type":"function","title":"Runlet.Event.Riemann.valid?/1","doc":"","ref":"Runlet.Event.Riemann.html#valid?/1"},{"type":"type","title":"Runlet.Event.Riemann.t/0","doc":"","ref":"Runlet.Event.Riemann.html#t:t/0"},{"type":"module","title":"Runlet.Event.Signal","doc":"Runlet signal events","ref":"Runlet.Event.Signal.html"},{"type":"type","title":"Runlet.Event.Signal.t/0","doc":"","ref":"Runlet.Event.Signal.html#t:t/0"},{"type":"module","title":"Runlet.Event.Stdin","doc":"Runlet stdin","ref":"Runlet.Event.Stdin.html"},{"type":"type","title":"Runlet.Event.Stdin.t/0","doc":"","ref":"Runlet.Event.Stdin.html#t:t/0"},{"type":"module","title":"Runlet.Event.Stdout","doc":"Runlet stdout events","ref":"Runlet.Event.Stdout.html"},{"type":"type","title":"Runlet.Event.Stdout.t/0","doc":"","ref":"Runlet.Event.Stdout.html#t:t/0"},{"type":"module","title":"Runlet.Event.Valve","doc":"Runlet valve events","ref":"Runlet.Event.Valve.html"},{"type":"type","title":"Runlet.Event.Valve.t/0","doc":"","ref":"Runlet.Event.Valve.html#t:t/0"},{"type":"protocol","title":"Runlet.Filter","doc":"","ref":"Runlet.Filter.html"},{"type":"function","title":"Runlet.Filter.proto/2","doc":"","ref":"Runlet.Filter.html#proto/2"},{"type":"type","title":"Runlet.Filter.t/0","doc":"All the types that implement this protocol.","ref":"Runlet.Filter.html#t:t/0"},{"type":"protocol","title":"Runlet.Fmt","doc":"","ref":"Runlet.Fmt.html"},{"type":"function","title":"Runlet.Fmt.fmt/1","doc":"","ref":"Runlet.Fmt.html#fmt/1"},{"type":"type","title":"Runlet.Fmt.t/0","doc":"All the types that implement this protocol.","ref":"Runlet.Fmt.html#t:t/0"},{"type":"module","title":"Runlet.History","doc":"Runlet command history tracked by user","ref":"Runlet.History.html"},{"type":"function","title":"Runlet.History.add/3","doc":"Add an item into a user's history.","ref":"Runlet.History.html#add/3"},{"type":"function","title":"Runlet.History.all/1","doc":"Complete history for a user.","ref":"Runlet.History.html#all/1"},{"type":"function","title":"Runlet.History.delete/2","doc":"Delete an item or items from a user's history.","ref":"Runlet.History.html#delete/2"},{"type":"function","title":"Runlet.History.lookup/2","doc":"Return the history for a user corresponding to a number or a list of numbers.","ref":"Runlet.History.html#lookup/2"},{"type":"type","title":"Runlet.History.t/0","doc":"","ref":"Runlet.History.html#t:t/0"},{"type":"module","title":"Runlet.PID","doc":"Conversion functions between Runlet and Erlang PIDs","ref":"Runlet.PID.html"},{"type":"function","title":"Runlet.PID.to_float/1","doc":"Convert an Elixir PID to a number","ref":"Runlet.PID.html#to_float/1"},{"type":"function","title":"Examples: - Runlet.PID.to_float/1","doc":"iex> Runlet.PID.to_float(:erlang.list_to_pid('<0.1234.0>'))\n    1234.0\n    iex> Runlet.PID.to_float(:erlang.list_to_pid('<0.1234.56>'))\n    1234.56","ref":"Runlet.PID.html#to_float/1-examples"},{"type":"function","title":"Runlet.PID.to_pid/1","doc":"Convert a representation of an Elixir PID.","ref":"Runlet.PID.html#to_pid/1"},{"type":"function","title":"Examples: - Runlet.PID.to_pid/1","doc":"iex> Runlet.PID.to_pid(String.to_integer(Runlet.PID.to_string(:erlang.list_to_pid('<0.1234.0>'))))\n    #PID<0.1234.0>","ref":"Runlet.PID.html#to_pid/1-examples"},{"type":"function","title":"Runlet.PID.to_string/1","doc":"Convert a Elixir PID to a string","ref":"Runlet.PID.html#to_string/1"},{"type":"function","title":"Examples: - Runlet.PID.to_string/1","doc":"iex> Runlet.PID.to_string(:erlang.list_to_pid('<0.1234.0>'))\n    \"1234\"\n    iex> Runlet.PID.to_string(:erlang.list_to_pid('<0.1234.56>'))\n    \"1234.56\"","ref":"Runlet.PID.html#to_string/1-examples"},{"type":"type","title":"Runlet.PID.t/0","doc":"","ref":"Runlet.PID.html#t:t/0"},{"type":"module","title":"Runlet.Process","doc":"Process job control","ref":"Runlet.Process.html"},{"type":"function","title":"Runlet.Process.add/3","doc":"Add a command to a user's process table.","ref":"Runlet.Process.html#add/3"},{"type":"function","title":"Runlet.Process.alive?/1","doc":"Tests if a PID is running.","ref":"Runlet.Process.html#alive?/1"},{"type":"function","title":"Runlet.Process.all/1","doc":"Retrieve a formatted process table for a user.","ref":"Runlet.Process.html#all/1"},{"type":"function","title":"Runlet.Process.boot/1","doc":"Restart saved processes.","ref":"Runlet.Process.html#boot/1"},{"type":"function","title":"Runlet.Process.delete/2","doc":"Delete a command from a user's process table.","ref":"Runlet.Process.html#delete/2"},{"type":"function","title":"Runlet.Process.format/2","doc":"Toggle formatting of events.","ref":"Runlet.Process.html#format/2"},{"type":"function","title":"Runlet.Process.kill/2","doc":"Terminate a process for a user.","ref":"Runlet.Process.html#kill/2"},{"type":"function","title":"Runlet.Process.limit/4","doc":"Sets the number of events allowed in a period of time (minutes). Events\nexceeding this limit are dropped.","ref":"Runlet.Process.html#limit/4"},{"type":"function","title":"Runlet.Process.lookup/2","doc":"Find a running command by PID.","ref":"Runlet.Process.html#lookup/2"},{"type":"function","title":"Runlet.Process.match/3","doc":"","ref":"Runlet.Process.html#match/3"},{"type":"function","title":"Runlet.Process.pexit/2","doc":"Force a process to exit.","ref":"Runlet.Process.html#pexit/2"},{"type":"function","title":"Runlet.Process.run/3","doc":"Run saved processes for a user.","ref":"Runlet.Process.html#run/3"},{"type":"function","title":"Runlet.Process.running/1","doc":"Return the list of running commands.","ref":"Runlet.Process.html#running/1"},{"type":"function","title":"Runlet.Process.start/2","doc":"Starts a stopped process.","ref":"Runlet.Process.html#start/2"},{"type":"function","title":"Runlet.Process.start_link/1","doc":"Restarts running processes.","ref":"Runlet.Process.html#start_link/1"},{"type":"function","title":"Runlet.Process.stop/3","doc":"Suppresses output for a process for the given number of minutes.","ref":"Runlet.Process.html#stop/3"},{"type":"function","title":"Runlet.Process.table/0","doc":"List available process tables.","ref":"Runlet.Process.html#table/0"},{"type":"function","title":"Runlet.Process.table/1","doc":"List process entries for a user.","ref":"Runlet.Process.html#table/1"},{"type":"type","title":"Runlet.Process.t/0","doc":"","ref":"Runlet.Process.html#t:t/0"},{"type":"protocol","title":"Runlet.Rate","doc":"","ref":"Runlet.Rate.html"},{"type":"function","title":"Runlet.Rate.rate/2","doc":"","ref":"Runlet.Rate.html#rate/2"},{"type":"type","title":"Runlet.Rate.t/0","doc":"All the types that implement this protocol.","ref":"Runlet.Rate.html#t:t/0"},{"type":"module","title":"Runlet.State","doc":"Persistent state storage for processes","ref":"Runlet.State.html"},{"type":"function","title":"Runlet.State.add/4","doc":"Add key/value to user state file.","ref":"Runlet.State.html#add/4"},{"type":"function","title":"Runlet.State.add/5","doc":"","ref":"Runlet.State.html#add/5"},{"type":"function","title":"Runlet.State.char_reserved?/1","doc":"Characters escaped by percent encoding. Allows @.","ref":"Runlet.State.html#char_reserved?/1"},{"type":"function","title":"Runlet.State.decode/1","doc":"Decode identifier from percent encoding.","ref":"Runlet.State.html#decode/1"},{"type":"function","title":"Runlet.State.delete/3","doc":"Remove key in user's state file.","ref":"Runlet.State.html#delete/3"},{"type":"function","title":"Runlet.State.delete/4","doc":"","ref":"Runlet.State.html#delete/4"},{"type":"function","title":"Runlet.State.encode/1","doc":"Percent encode identifier in a filesystem safe format.","ref":"Runlet.State.html#encode/1"},{"type":"function","title":"Runlet.State.exists?/1","doc":"Test if a state dir for a user exists.","ref":"Runlet.State.html#exists?/1"},{"type":"function","title":"Runlet.State.exists?/2","doc":"Test if a given state file exists for a user.","ref":"Runlet.State.html#exists?/2"},{"type":"function","title":"Runlet.State.path/0","doc":"Storage location for runlet state.","ref":"Runlet.State.html#path/0"},{"type":"function","title":"Runlet.State.table/2","doc":"Lists all entries in a state file for a user.","ref":"Runlet.State.html#table/2"},{"type":"function","title":"Runlet.State.table/3","doc":"","ref":"Runlet.State.html#table/3"},{"type":"extras","title":"Overview","doc":"# Runlet\n\n[![Package Version](https://img.shields.io/hexpm/v/runlet)](https://hex.pm/packages/runlet)\n[![Hex Docs](https://img.shields.io/badge/hex-docs)](https://hexdocs.pm/runlet/)\n\nA job command language for querying and enforcing flow control on\nevent streams. `runlet` is a library used for event notifications in\nmonitoring systems.\n\n`runlets` are light weight processes connecting to an event source\nsimilar to a shell pipeline. The output of a runlet can be temporarily\nstopped or terminated using job control commands.\n\nAn event source could be a monitoring system like\n[Riemann](http://riemann.io/) or the standard output of a containerized\nsystem process.\n\nThe event stream is piped through commands to transform and rate limit\nevents before being outputted.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"Add runlet to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:runlet, git: \"https://github.com/msantos/runlet.git\"}]\nend\n```","ref":"readme.html#installation"}],"content_type":"text/markdown"}